var dialog
//func format delle date
function format_date(date) {
	return new moment(date).format('YYYY-MM-DD HH:mm:SS')
}

// func per serializzare il form
$.fn.serializeObject = function() {
	var o = {};
	var a = this.serializeArray();
	$.each(a, function() {
		if (o[this.name] !== undefined) {
			if (!o[this.name].push) {
				o[this.name] = [ o[this.name] ];
			}
			o[this.name].push(this.value || '');
		} else {
			o[this.name] = this.value || '';
		}
	});
	return o;
};
//imposta il csrf token
var _sync = Backbone.sync;
Backbone.sync = function(method, model, options) {
	options.beforeSend = function(xhr) {
		var token = $('meta[name="csrf-token"]').attr('content');
		xhr.setRequestHeader('X-CSRFToken', token);
	};
	return _sync(method, model, options);
};

var Ticket = Backbone.Model.extend({
	//colori delle priorità
	priority_color_text : [ 'white', 'black', 'white', 'white', 'white', 'black'],
	priority_color : [ 'red', 'orange', 'green', 'blue', 'violet', 'lightseagreen'],
	method_urls : {
		"create" : "/admin/ticket/ticket/add/?json=true",
		"update" : "/admin/ticket/ticket/",
		"delete" : "/admin/ticket/ticket/",
	},
	url : function() {
		return this.method_urls['update'] + this.get("id") + "/?patch=true"
	},
	sync : function(method, model, options) {

		options = options || {};

		if (method == "update") {
			options.url = this.method_urls[method] + model.get("id") + "/"
		}
		if (method == "create") {
			options.url = this.method_urls[method]
		}
		if (method == "delete") {
			options.url = this.method_urls[method] + model.get("id")
					+ "/delete/"
		}

		return Backbone.sync.apply(this, arguments);
	},

	toBePlanned : function() {
		return this.get("to_be_planned")
		//vecchia funzione che conta i plan collegati
		/*ticket_id = this.get("id")
		var allplans = plans.filter(function(model){ 
			return model.attributes.ticket == ticket_id; 
		})
		return (!(allplans.length > 0))
		 */
	},
	related_url : function() {
		// http://localhost:8000/admin/ticket/ticket/?project=2&status__in=1&triggerline__gte=&triggerline__lte=
		//ritorna i ticket dello stesso progetto
		params = $.param({
			project : this.get("project"),
			status__in : 1
		});
		return "/admin/ticket/ticket/iframe_list/?" + params
	},
	get_color : function() {
		return this.priority_color[this.get("priority")]
	},
	get_color_text : function() {
		return this.priority_color_text[this.get("priority")]
	},
	initialize : function() {
		delete this.attributes.date_create
		delete this.attributes.date_last_modify
	},
	chiudi : function() {
		this.save({
			status : 0
		}, {
			patch : true,
			emulateHTTP : true,
			wait : true
		})
	},
	update : function(data) {
		myself = this
		myself.set(data);
	}
});

var TicketCollection = Backbone.Collection.extend({
	model : Ticket,
	url : '/admin/ticket/ticket/',
	// ritorna gli schedulati non piu usata
	/*
	scheduled: function(condition){
	   condition = (typeof(condition) == "undefined")? true : condition 
	   return this.filter(function(model){ 
		   ticket_id = model.attributes.id
		   var allplans = plans.filter(function(model){ 
			   		return model.attributes.ticket == ticket_id; 
	 		   })
		   return allplans.length > 0 == condition
		   })
	},
	 */
	comparator : function(item) {
		return item.get('priority');
	},
	onModelAdd : function(model, collection, options) {
		t = new TicketView({
			model : model
		})
		// se deve comparire nella board
		if (collection.ticketboard) {
			$("#ticketboard").append(t.el)
		}

		id = model.get("id")
		// plans collegati
		plans_related = plans.filter(function(model) {
			return model.get("ticket") == id
		})
		// Setta gli eventi e renderizza
		_.each(plans_related, function(x) {
			x.set_ticket_event()
			x.render()
		})

	},
	ordina : function() {
		$("#ticketboard .ticket").tsort({
			attr : "priority"
		});
	},
	onModelRemoved : function(model, collection, options) {
		model.trigger("change")
	},
	initialize : function(models, options) {
		this.ticketboard = options.ticketboard
		this.bind('remove', this.onModelRemoved, this);
		this.bind("add", this.onModelAdd, this);
		this.bind("sort", this.ordina, this);
	},
	//formatta il contenuto serizliazzato di django
	parse : function(array) {
		myself = this
		return _.map(array, function(y) {
			return ticket_parse(y)
		})
	}
});
//checkbox nascondi i pianificati
var TicketShowView = Backbone.View.extend({
	el : "#ticket_show",
	events : {
		'click' : 'clicked',
	},
	clicked : function(event) {
		_.each(tickets.models, function(t) {
			t.trigger("change")
		})
	},
	status : function() {
		return this.$el.is(':checked')
	}
});

var TicketView = Backbone.View.extend({

	tagName : "div",
	className : "ticket",
	initialize : function() {
		//quando viene cambiato il modello viene chiamata la func render sotto
		this.listenTo(this.model, "change", this.render);
		this.render()
		var planObject = {
			ticket_id : jQuery.trim(this.model.get('id'))
		};
		this.$el.data('planObject', planObject);
		// make the event draggable using jQuery UI
		this.$el.draggable({
			scroll : false,
			snap : "#calendar",
			start : function(event, ui) {
				ui.helper.css("position", "absolute").css("width", '180px')
			},
			stop : function(event, ui) {
				ui.helper.css("position", "relative")
			},
			drag : function(event, ui) {
				ui.position.top = event.pageY - $("#ticketboard").offset().top
						+ 10
			},
			position : "absolute",
			zIndex : 99999,
			revert : true, // will cause the event to go back to its
			revertDuration : 0
		//  original position after the drag
		});

	},
	get_color : function() {
		return this.model.get_color()
	},
	get_color_text : function() {
		return this.model.get_color_text()
	},
	render : function() {
		if(this.model.get("status")==0){
			this.$el.addClass("plight")
			this.$el.hide();
			return false
		}
		if (ticketshowview.status()) {
			this.$el.removeClass("plight")
			//se in nascondi pianificati
			if (this.model.toBePlanned()) {
				//se si devono pianificare mostrali
				this.$el.show();
			} else {
				//altrimenti già pianificati nascondi
				this.$el.hide()
			}
		} else {
			this.$el.show();
		}
		if (this.model.toBePlanned()) {
			this.$el.show();
		}
		this.$el.html(this.model.get("title"))
		this.$el.css("background-color", this.get_color())
		this.$el.css("color", this.get_color_text())
		this.$el.attr('cid', this.model.get("id"))
		this.$el.data('cid', this.model.get("id"))
		this.$el.data('ticket_id', this.model.get("id"))
		this.$el.attr('rel', 'popover')
		this.$el.attr('priority', this.model.get("priority"))
		this.$el.data('priority', this.model.get("priority"))
		this.$el.attr('data-content', this.model.get("description"))
		this.$el.attr('data-original-title', this.model.get("title"))
		this.$el.popover({
			html: true,
			delay: { show: 100, hide: 100 },
			trigger: 'hover',
			container: "#ticketpopover",
		})
		tickets.ordina()
	}

});

var FormView = Backbone.View.extend({
	tagName : "div",
	className : "form",
	model : Plan,
	add_url : function(){
		if (amode) return "/admin/ticket/ticketassistance/add/?jpopup=true&_popup=true"
		return "/admin/ticket/plan/add/?jpopup=true"
	},
	edit_url : function(){
		if (amode) return "/admin/ticket/ticketassistance/"
		return "/admin/ticket/plan/"
	},
	//rappresenta il form nel template
	el : "#form_modal",
	initialize : function(opts) {
		this.set_ajax_form(opts)
	},
	get_url : function() {
		if (this.model) {
			return this.edit_url() + this.model.get("id")
					+ "/?json=true&jpopup=true"
		} else {
			return this.add_url()
		}
	},
	set_ajax_form : function(opts) {
		custom_url = this.get_url()
		opts = opts || {};
		myself = this
		$.ajax({
			type : "GET",
			url : custom_url,
			data : opts
		}).done(function(html) {
			myself.set_html(html)
			return true
		});
	},
	post : function() {
		myself = this
		//se è una modifica
		if (this.model) {
			model = this.model
			data = this.json_data()
			delete data.date_begin
			delete data.date_end
			if (data.workers == undefined) {
				data.workers = []
			}
			_.each(data, function(val, col) {
				if (val)
					model.set(col, val);
			});
			this.model.save(this.model.toJSON(), {
				success : function(model, response) {
					//setta il titolo del plan
					model.set("title", response[0].extras.label)
					//Renderizza il plan
					model.render()
					myself.hide()
				},
				error : function(model, response) {
					myself.set_html(response.responseText)
				},
			})

		} else {
			//se è un nuovo plan
			plan = new Plan(myself.json_data())
			plan.save(plan.toJSON(), {
				success : function(model, response) {
					//Setta id e label, renderizza e aggiunge alla
					// collezzione
					plan.set("id", response[0].pk)
					plan.set("title", response[0].extras.label)
					plan.render()
					plans.add(plan)
					//setta tiket to be planned forse va nell onmodeladd?
					if (TICKET_SINGLE_PLAN)
					plan.ticket().set("to_be_planned",false);
					
					myself.hide()
				},
				error : function(model, response) {
					myself.set_html(response.responseText)
				},
			})
			return false;
		}
	},
	set_form : function(e) {
		this.$el.find("form").html(e)
	},
	json_data : function() {
		data = this.$el.find("form").serializeObject()
		data.start = data.date_begin
		data.end = data.date_end
		return data
	},
	set_html : function(html) {
		//setta l html del form
		myself = this
		this.$el.find(".modal-dialog-ui").html(html)
		var form = this.$el.find("form")
		$(form).unbind("submit");
		$(form).submit(function(event) {
			event.preventDefault();
			myself.post()
			return false;
		});

	},
	show : function() {
		//mostra la modale
		myself = this
		$(this.$el).dialog({
			modal : true,
			width : 700,
			height : 550,
			closeText : "Annulla",
			close: function( event, ui ) {
				myself.set_html(" ")
			},
			buttons : {
				Chiudi : function() {
					$(this).dialog("close");
				}
			}
		});
	},
	hide : function() {
		this.$el.dialog("close");
	}
});

var FormTicketView = Backbone.View
		.extend({
			tagName : "div",
			className : "form",
			add_url : "/admin/ticket/ticket/add/?jpopup=true",
			edit_url : "/admin/ticket/ticket/",
			// rappresenta il form nel template
			el : "#form_modal",
			initialize : function(opts) {
				if (this.model) {
					var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
					dialog = $("<div></div>").append(iframe).appendTo("body")
							.dialog({
								autoOpen : false,
								modal : true,
								resizable : true,
								width : "auto",
								height : "auto",
								close : function() {
									iframe.attr("src", "");
								},
								open: function(event, ui) {
									iframe.attr({
										width : '100%',
									});
									iframe.parents(".ui-dialog").css('width','1000px');
									$(".ui-dialog-titlebar-close").html("X")
								}
							});
					var src = this.get_url()
					var title = gettext('Edit')
					var width = 1000
					var height = 650
					iframe.attr({
						width : +width,
						height : +height,
						src : src
					});

					dialog.dialog("option", "title", title).dialog("open");

				} else {
					var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
					dialog = $("<div></div>").append(iframe).appendTo("body")
							.dialog({
								autoOpen : false,
								modal : true,
								resizable : true,
								width : "auto",
								height : "auto",
								close : function() {
									iframe.attr("src", "");
								},
								open: function(event, ui) {
									iframe.attr({
										width : '100%',
									});
									iframe.parents(".ui-dialog").css('width','1000px');
									$(".ui-dialog-titlebar-close").html("X")
								}
							});
					var src = this.get_url()
					var title = gettext("New")
					var width = 1000
					var height = 650
					iframe.attr({
						width : +width,
						height : +height,
						src : src
					});

					dialog.dialog("option", "title", title).dialog("open");
				}
			},
			get_url : function() {
				if (this.model) {
					return this.edit_url + this.model.get("id") + "/?jpopup=true"
				} else {
					return this.add_url
				}
			}
		});


var FormAssistenzaView = Backbone.View
		.extend({
			tagName : "div",
			model: Plan,
			className : "form",
			add_url : "/admin/ticket/ticketassistance/add/?_popup=1",
			edit_url : "/admin/ticket/ticketassistance/",
			// rappresenta il form nel template
			el : "#form_modal",
			initialize : function(opts) {
					var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
					dialog = $("<div></div>").append(iframe).appendTo("body")
							.dialog({
								autoOpen : false,
								modal : true,
								resizable : true,
								width : "auto",
								height : "auto",
								close : function() {
									iframe.attr("src", "");
								},
								open: function(event, ui) {
									iframe.attr({
										width : '100%',
									});
									iframe.parents(".ui-dialog").css('width','1000px');
									$(".ui-dialog-titlebar-close").html("X")
								}
							});
					var src = this.get_url()
					var title = gettext("New")
					var width = 1000
					var height = 650
					iframe.attr({
						width : +width,
						height : +height,
						src : src
					});

					dialog.dialog("option", "title", title).dialog("open");

			},
			get_url : function() {
					return this.add_url +"&plan="+this.model.get("id")
			}
		});

var FormPlanView = Backbone.View
		.extend({
			tagName : "div",
			className : "form",
			add_url : function(){
				if (amode) return "/admin/ticket/ticketassistance/add/?"
				return "/admin/ticket/plan/add/?"
			},
			edit_url : function(){
				if (amode) return "/admin/ticket/ticketassistance/"
				return "/admin/ticket/plan/"
			}, 
			// rappresenta il form nel template
			el : "#form_modal",
			initialize : function(opts) {
				if (this.model) {
					var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
					dialog = $("<div></div>").append(iframe).appendTo("body")
							.dialog({
								autoOpen : false,
								modal : true,
								resizable : true,
								width : "auto",
								height : "auto",
								close : function() {
									iframe.attr("src", "");
								},
								open: function(event, ui) {
									iframe.attr({
										width : '100%',
									});
									iframe.parents(".ui-dialog").css('width','900px');
									$(".ui-dialog-titlebar-close").html("X")
								}
							});
					var src = this.get_url(opts)
					var title = gettext("Edit")
					var width = 1000
					var height = 650
					iframe.attr({
						width : +width,
						height : +height,
						src : src
					});

					dialog.dialog("option", "title", title).dialog("open");

				} else {
					var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
					dialog = $("<div></div>").append(iframe).appendTo("body")
							.dialog({
								autoOpen : false,
								modal : true,
								resizable : true,
								width : "auto",
								height : "auto",
								close : function() {
									iframe.attr("src", "");
								},
								open: function(event, ui) {
									iframe.attr({
										width : '100%',
									});
									iframe.parents(".ui-dialog").css('width','900px');
									$(".ui-dialog-titlebar-close").html("X")
								}
							});
					var src = this.get_url(opts)
					var title = gettext("New")
					var width = 1000
					var height = 650
					iframe.attr({
						width : +width,
						height : +height,
						src : src
					});

					dialog.dialog("option", "title", title).dialog("open");
				}
			},
			get_url : function(opts) {
				opts.jpopup = true
				if (this.model) {
					opts = _.extend(opts,this.model.toJSON())
					if (amode){
						opts.date_end = new moment(opts.date_end).format("HH:mm:SS")
					}
					return this.edit_url() + this.model.get("id")+ "/?" + $.param(opts)
				} else {
					if (amode){
						opts.date_end = new moment(opts.date_end).format("HH:mm:SS")
					}
					return this.add_url() + ($.param(opts))
				}
			}
		});


var FormTicketProjectView = Backbone.View
		.extend({
			tagName : "div",
			className : "form",
			edit_url : TICKETPROJECT_EDIT_URL,
			initialize : function(opts) {
				if (this.model) {
					var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
					dialog = $("<div></div>").append(iframe).appendTo("body")
							.dialog({
								autoOpen : false,
								modal : true,
								resizable : true,
								width : "auto",
								height : "auto",
								close : function() {
									iframe.attr("src", "");
								},
								open: function(event, ui) {
									iframe.attr({
										width : '100%',
									});
									iframe.parents(".ui-dialog").css('width','1000px');
									$(".ui-dialog-titlebar-close").html("X")
								}
							});
					var src = this.get_url()
					var title = gettext("Edit")
					var width = 1000
					var height = 650
					iframe.attr({
						width : +width,
						height : +height,
						src : src
					});

					dialog.dialog("option", "title", title).dialog("open");

				}
				return false
			},
			get_url : function() {
				if (this.model) {
					return this.edit_url.replace("999",this.model.get("project").id) + "?jpopup=true"
				}
				return false
			}
		});


var Plan = Backbone.Model
		.extend({
			//imposta gli url corretti dell admin
			method_urls : function() {
				if(amode){
					
					return { "create" : "/admin/ticket/ticketassistance/add/?json=true",
						"update" : "/admin/ticket/ticketassistance/",
						"patch" : "/admin/ticket/ticketassistance/",
						"read" : "/admin/ticket/ticketassistance/",
						"delete" : "/admin/ticket/ticketassistance/"}
					
				}
				return { "create" : "/admin/ticket/plan/add/?json=true",
				"update" : "/admin/ticket/plan/",
				"patch" : "/admin/ticket/plan/",
				"read" : "/admin/ticket/plan/",
				"delete" : "/admin/ticket/plan/"}
				
			},
			pdf_url: function(){
				return PLAN_PRINT_URL.replace(999,this.get("id"))
			},
			send_url: function(){ 
				return PLAN_INVITATION_URL.replace(999,this.get("id"))
			},
			send_invitation: function(){
				
				var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
				dialog = $("<div></div>").append(iframe).appendTo(
						"body").dialog({
					autoOpen : false,
					modal : true,
					resizable : true,
					width : 300,
					height : 300,
					close : function() {
						iframe.attr("src", "");
					},
					open: function(event, ui) {
						iframe.attr({
							width : '300px',
						});
						iframe.parents(".ui-dialog").css('width','300px');
						$(".ui-dialog-titlebar-close").html("X")
				    }
				});

				var src = this.send_url()
				var title = gettext("Send Invitation")
				var width = 300
				var height = 300
				iframe.attr({
					width : +width,
					height : +height,
					src : src
				});
				dialog.dialog("option", "title", title).dialog(
						"open");
				
		
			},
			load_pdf: function(){
				url  = this.pdf_url()
				$.blockUI({
					message: gettext("Please Wait"),
					overlayCSS: { backgroundColor: 'trasparent' },
					css: { 
			            border: 'none', 
			            padding: '15px', 
			            backgroundColor: 'rgb(240, 240, 240)', 
			            '-webkit-border-radius': '10px', 
			            '-moz-border-radius': '10px', 
			            opacity: .8, 
			        }
				});
				setTimeout($.unblockUI, 1000);
				$("#printpdf").attr('src',url)
		 /*
		        $.fileDownload(url, {
		            successCallback: function (url) {
		            	$.unblockUI
		            },
		            failCallback: function (responseHtml, url) {
		            	$.unblockUI
		            	failmsg = responseHtml
		            	$("<div>"+ failmsg+ "</div>").dialog({
							modal : true,
							open: function(event, ui) {
								$(".ui-dialog-titlebar-close").html("X")
						    }
						});
		            }
		        });
		        */
			},
			update: function (data) {
				myself = this
				myself.set(data);
			},
			sync : function(method, model, options) {

				options = options || {};

				if (method == "update" || method == "read" || method =="patch") {
					options.url = this.method_urls()[method] + model.get("id")
							+ "/?json=true"
				}
				if (method == "create") {
					options.url = this.method_urls()[method]
				}
				if (method == "delete") {
					options.url = this.method_urls()[method] + model.get("id")
							+ "/delete/?post=yes"
				}

				return Backbone.sync.apply(this, arguments);
			},
			set_ticket_event : function() {
				if (this.ticket()) {
					this.listenTo(this.ticket(), "change:priority change:description change:title change:status",
							this.reload);
				}
				return false
			},
			single_plan : function() {
				if (TICKET_SINGLE_PLAN == false)
					return false;
				if (this.ticket()) {
					ticket = this.ticket()
					ticket.set("to_be_planned", true)
					ticket.trigger("change")
				}
			},
			initialize : function() {
				//ascolta il cambiamento proprio
				this.on('change:workers', this.render, this);
				this.on('change:display', this.render, this);
				//alla cancellazione imposta ticket a to be planned
				// se opportuno
				this.on('destroy', this.single_plan, this);
				if (this.ticket()) {
					this.set_ticket_event()
					this.render()
				}

			},
			reload: function(){
				myself=this
				this.sync('read',this,{
					success: function(model, response) {
						data_json = plan_parse(model[0])
					    myself.update(data_json)
					    myself.render()
					}
				})
			},
			short_title: function(){
				sp = this.get("title").split("<br>")
				st = sp[0].replace(/(<([^>]+)>)/ig,"").trim()
				if(!(st)){
					st = sp[1].replace(/(<([^>]+)>)/ig,"").trim()
				}
				return st
				
			},
			//renderizza l evento sul calendario
			render : function() {
				if(!(this.ticket())) return false
				//html = "prj id:" + this.ticket().get("project") + ", workers: " + this.get("workers")
				/*
				ticket_title = this.ticket().get("title")
				workers_names = "Nessun Worker"
				if (this.workers().length){
				  workers_names = _.map(this.workers(),function(x){
					  return x.get("first_name") + " " + x.get("last_name")
					  }).toString();
				}
				html = ticket_title + "; "+workers_names
				 */
				
				
				this.set("opacity", "0.5")
				this.set("title", this.get('title'))
				this.set("backgroundColor", this.ticket().get_color())
				this.set("textColor", this.ticket().get_color_text())
				this.set("borderColor", this.ticket().get_color())
				planid= "#" + this.get("id")+"#"
				plan=this
				op = (this.ticket().get("status")) ? "pdark "+planid: "plight " +planid
				this.set("className", (this.display()) ? 'fc-visible ' + op
						: 'fc-hidden ' + op )
				evt = $(calendar).fullCalendar('clientEvents', this.get("id"))
				if(calendar_viewname=="month"){
					titolo = this.short_title()
				}else{
					titolo = this.get('title')
				}
				
				if (evt.length) {
					//ricrea l obj evento da dare al full calendar
					evt[0].title = titolo;
					evt[0].backgroundColor = this.get("backgroundColor");
					evt[0].color = this.get("color");
					evt[0].borderColor = this.get("borderColor");
					evt[0].className = this.get("className");
					evt[0].start= new Date(plan.get("start"))
					evt[0].end= new Date(plan.get("end"))
					//se va mostrato aggiorna l evento
					if (this.display()) {
						$(calendar).fullCalendar('updateEvent', evt);
						console.log('update')
					//altrimenti lo elimina
					} else {
						$(calendar)
								.fullCalendar('removeEvents', this.get("id"))
					}
				} else {
					//se non ce l evento allora lo crea per la prima volta
					if (this.display()) {
						json = this.toJSON()
						json.title = titolo
						$(calendar).fullCalendar('renderEvent', json)
						console.log('render')
					}
				}
			},
			//func chiamata al change sul calendario
			//revertfunc rappresenta  l operazione annulla
			//se il save non restituisce 200
			dragupdate : function(event, revertFunc) {
				myself = this
				var date_end = format_date(event.end)
				if(amode) date_end = new moment(event.end).format("HH:mm")
				
				this.save({
					date_begin : format_date(event.start),
					date_end : date_end,
					ticket: myself.get("ticket")
				}, {
					patch : true,
					emulateHTTP : true,
					wait : true,
					error : function(model, response) {
						revertFunc()
					},
					success : function(model, response) {
						myself.set("start",format_date(event.start))
						myself.set("end",format_date(event.end))
					},
				})
				
			},
			ticket : function() {
				ticket_id = this.get("ticket")
				tic = tickets.get({
					id : ticket_id
				})
				if (tic) {
					return tic
				} else {
					ticketsdb.get({
						id : ticket_id
					})
				}
			},
			workers : function() {
				workers_ids = this.get("workers")
				return workers.filter(function(model) {
					return workers_ids.indexOf(model.attributes.id) != -1;
				})
			},
			display : function() {
				selected_workers_el = $("#staff-select")
						.find("option:selected")
				selected_workers = $.map(selected_workers_el, function(o) {
					return parseInt($(o).attr("name"));
				})
				if (!(selected_workers.length))
					return true
				map = _.map(this.get("workers"), function(single_worker) {
					return _.contains(selected_workers, single_worker)
				})
				return _.compact(map).length == true
			}

		});

var Contact = Backbone.Model.extend({
	display_name : function() {
		return this.get("get_full_name")
	}
});


var DatePickView = Backbone.View.extend({
	events: {
        "submit form": "setdate"
    },
    setdate:function(){
    	vdate = vdate = $("#datepicker").datepicker( "getDate" );
    	dt = new Date(vdate)
    	if(!(dt)) alert(gettext("Date Invalid"))
    	calendar_view = $(calendar).fullCalendar('gotoDate', dt)
    	return false;
    },
	update: function(){
		calendar_view = $(calendar).fullCalendar('getView')
		dt = calendar_view.start
		$("#datepicker").datepicker("setDate", dt );
		},
	initialize : function(){
		$(".fc-header-left").append("<span id='datepickspan'><form><input id='datepicker' type='text' />"+
				"<input type='submit' value='"+gettext('Go')+"'/></form></span>")
		this.$el = $('#datepickspan')
		this.$el.find("#datepicker").datepicker()
		}
});


var StaffOptionView = Backbone.View.extend({
	tagName : "option",
	model : Contact,
	initialize : function() {
		//this.listenTo(this.model, "change:priority", this.render);
	},
	render : function() {
		return $("<option />").html(this.model.display_name()).attr("cid",
				this.model.get("id")).attr("name", this.model.get("id"))
	}

});
var StaffCollection = Backbone.Collection.extend({
	model : Contact,
	initialize : function() {
		this.bind("add", this.onModelAdd, this);
		this.bind("remove", this.onModelRemove, this);
	},
	onModelAdd : function(model, collection, options) {
		view = new StaffOptionView({
			model : model
		})
		$("#staff-select").prepend(view.render())
		$("#staff-select").trigger("chosen:updated");
	},
	onModelRemove : function(model, collection, options) {
		view = new StaffOptionView({
			model : model
		})
		$("#staff-select").find("option[cid='" + model.get("id") + "']")
				.remove()
	},
	parse : function(array) {
		myself = this
		return _.map(array, function(y) {
			y.fields.id = y.pk
			y.fields.get_full_name = y.extras.get_full_name
			return y.fields
		})
	},
	
});

var WorkerCollection = Backbone.Collection.extend({
	model : Contact,
	url : '/admin/ticket/ticket/workers/',
	parse : function(array) {
		myself = this
		return _.map(array, function(y) {
			y.fields.id = y.pk
			y.fields.get_full_name = y.extras.get_full_name
			return y.fields
		})
	},
	initialize : function() {
		this.bind("add", this.onModelAdd, this);
	},
	onModelAdd : function(model, collection, options) {

		id = model.get("id")
		/*
		plans_related = plans.filter(function(model){ 
			   		return model.get("workers").indexOf(id) != -1; 
			   })
		_.each(plans_related, function(x){x.trigger("change:workers")})
		 */
	},

});

var workers = new WorkerCollection()
var staff = new StaffCollection()
//crea la collezione setta come sorgente url ovvero il json delle assistenze
var PlanCollection = Backbone.Collection.extend({

	url : function(){
		if(amode) return  '/admin/ticket/ticketassistance/?json=true'
		return  '/admin/ticket/plan/?json=true'
	},
	model : Plan,
	//modifica l organizzazione dei dati
	parse : function(array) {
		return _.map(array, function(y) {
			return plan_parse(y)
		})
	},
	onModelRemoved : function(model, collection, options) {
		$(calendar).fullCalendar('removeEvents', model.get("id"))
		model.destroy()
	},
	onModelAdd : function(model, collection, options) {
		if (model.ticket())
			model.ticket().trigger('change');
	},
	initialize : function() {
		this.bind('remove', this.onModelRemoved, this);
		this.bind("add", this.onModelAdd, this);
		this.on("reset", this.onCollectionReset, this);
	},
	onCollectionReset : function() {
		//al reset cancella tutti i plan
		$(calendar).fullCalendar('removeEvents')
	},
	retrive : function(params) {
		myself = this
		$.blockUI({
			message: gettext("Please Wait"),
			overlayCSS: { backgroundColor: 'trasparent' },
			css: { 
	            border: 'none', 
	            padding: '15px', 
	            backgroundColor: 'rgb(240, 240, 240)', 
	            '-webkit-border-radius': '10px', 
	            '-moz-border-radius': '10px', 
	            opacity: .8, 
	        }
		});
		calendar_view = $(calendar).fullCalendar('getView')
		params = params || {}
		params.date_begin__gte = params.date_begin__gte
				|| format_date(calendar_view.visStart)
		params.date_end__lte = params.date_end__lte
				|| format_date(calendar_view.visEnd)
		this.reset()
		this.fetch({
			data : params,
			processData : true,
			remove : false,
			// fa la fetch dei workers e tickets collegati
			// se non presenti nelle collezzioni
			success : function() {
				workers_ids = myself.pluck("workers")
				workers_array = _.map(workers_ids, function(x) {
					if(x) return x[0];
				})
				workers_array = _.compact(workers_array)
				workers_uniq = _.unique(workers_array)
				workers_diff = _.difference(workers_uniq, workers.pluck("id"))
				tickets_array = myself.pluck("ticket")
				tickets_uniq = _.unique(tickets_array)
				tickets_diff = _
						.difference(tickets_uniq, ticketsdb.pluck("id"))
				if (tickets_diff.length) {
					ticketsdb.fetch({
						data : {
							id : tickets_diff
						},
						processData : true,
						remove : false
					})
				}
				if(workers_diff.length){
				workers.fetch({
					data : {
						id : workers_diff
					},
					processData : true,
					remove : false
				})
				}
				$.unblockUI();
			}
		});
	},
	update : function() {

		/*
		selected_workers = $("#staff-select").find("option:selected")
		selected_plans = plans.filter(function(plan){
			workers_list = plan.get("workers")
			ret= workers_list.filter(function(w){
				return _.contains(selected_workers,w)
			})
			return ret.length
		})
		 */
		_.each(plans.models, function(plan) {
			plan.trigger("change:display")
		})

	}
});

plans = new PlanCollection()

//Crea la collezione
tickets = new TicketCollection([], {
	ticketboard : true
})
ticketsdb = new TicketCollection([], {
	ticketboard : false
})

var datepick 
function datepickupdate(){
	datepick = (datepick) ? datepick : new DatePickView({el :"#datepicker"})
	datepick.update()
}
//fa la chiamata
$(function() {
	//checkbox
	ticketshowview = new TicketShowView({
		el : "#ticket_show"
	})
	_.each(ticket_json, function(x) {
		x = ticket_parse(x)
		tickets.add(x);
		ticketsdb.add(x);
	})

	load_calendar();
	//prende le visualizzazione corrente del calendario
	calendar_view = $(calendar).fullCalendar('getView')
	plans.retrive()

	_.each(staff_json, function(x) {
		x.fields.id = x.pk
		x.fields.get_full_name = x.extras.get_full_name
		staff.add(x.fields);
	})
	$("#staff-select").chosen();
	$("#staff-select").on('change', function(evt, params) {
		plans.update()
	});

	document.getElementById("printpdf").onload = function() {
		window.frames['printpdf'].print()
		};
		
});
var calendar_viewname = "agendaDay"
function load_calendar() {

	var date = new Date();
	var d = date.getDate();
	var m = date.getMonth();
	var y = date.getFullYear();
	var calendar = jQuery('#calendar')
			.fullCalendar(
					{

						// General Display
						header : {
							left : 'prev,next today prevYear, nextYear',
							center : 'title',
							right : 'month,agendaWeek,agendaDay,agendaWeek2'
						},
						buttonText: {
							prev: "<span class='fc-text-arrow'>&lsaquo;</span>",
							next: "<span class='fc-text-arrow'>&rsaquo;</span>",
							prevYear: "<span class='fc-text-arrow'>&laquo;</span>",
							nextYear: "<span class='fc-text-arrow'>&raquo;</span>",
							today: gettext('today'),
							month: gettext('month'),
							week: gettext('week'),
							week2: gettext('3 Days'),
							day: gettext('day')
						},
						firstDay : 1,
						weekends : false,
						weekNumbers : true,
						viewDisplay : function(view) {
							// alert('Apertura Calendario');
						},
						windowResize : function(view) {
							// alert('Window Resize');
						},

						// Agenda Options
						allDayDefault : false,
						weekends: true,
						hiddenDays: TICKET_HIDDEN_DAYS,
						defaultView : TICKET_CALENDAR_VIEW,
						// allDaySlot: false,
						allDayText : 'all day',
						slotMinutes : 15,
						firstHour : 9,
						minTime : 7,
						maxTime : 20,
						slotEventOverlap : false,

						// Text/Time Customization
						titleFormat: {
							month: 'MMMM yyyy',
							week: "d/M{ '&#8212;'[ MMM] d/M}",
							day: 'dddd, d/M',
							week2: "d/M{ '&#8212;'[ MMM] d/M}",
						},
						columnFormat: {
							month: 'dddd',
							week: 'dddd d/M',
							week2: 'dddd d/M',
							day: 'dddd d/M'
						},
						timeFormat: { // for event elements
							'': 'h(:mm)t' // default
						},
						dayNames : [ 'Domenica', 'Lunedì', 'Martedì',
								'Mercoledì', 'Giovedì', 'Venerdì', 'Sabato' ],
						dayNamesShort : [ 'Dom', 'Lun', 'Mar', 'Mer', 'Gio',
								'Ven', 'Sab' ],
						weekNumberTitle : 'N.S.',

						//al cambiamento della view
						viewRender : function(view, element) {
							calendar_viewname = $(calendar).fullCalendar('getView').name
							plans.retrive()
							
							datepickupdate()

						},
						// Clicking
						dayClick : function(date, allDay, jsEvent, view) {

							//jQuery(this).css('background-color', 'red');
						},
						eventDrop : function(event, dayDelta, minuteDelta,
								allDay, revertFunc, jsEvent, ui, view) {
							plan = plans.get({
								id : event.id
							})
							plan.dragupdate(event, revertFunc)
						},
						eventResize : function(event, dayDelta, minuteDelta,
								allDay, revertFunc, jsEvent, ui, view) {
							plan = plans.get({
								id : event.id
							})
							plan.dragupdate(event, revertFunc)
						},
						eventClick : function(calEvent, jsEvent, view) {
						},
						eventMouseover : function(event, jsEvent, view) {
							//alert('Event: ' + calEvent.title);
						},
						eventMouseout : function(event, jsEvent, view) {
							//alert('Event: ' + calEvent.title);
						},
						eventAfterRender : function(event, element, view) {
							if(view.name=="month"){
								//var html = $(element).find(".fc-event-title").html().split("<br>")[0]
								//$(element).find(".fc-event-title").html(html)
								//$(element).css("max-height",'10px').css("overflow",'hidden')
							}
							plan_id = event.id
							plan = plans.get({id:plan_id})
							//popover
							if (plan){
								$(element).data('plan_id', plan_id);
								$(element).attr('plan_id', plan_id);
								$(".popover").remove()
								var $popover = $(element).popover({
									html: true,
									placement: 'top',
									title: '',
									trigger: 'hover',
									delay: { show: 100, hide: 100 },
						        	content: plan.get("title"),
						        	container: "#planpopover",
						        	});
								$popover.on("shown", function(e) {
									//Setup dei colori della priorità
									
									color = $(this).css("background-color")
									pop = $("#planpopover .popover").last()
									$(pop).find(".popover-content").css("borderColor",color)
									var max = $(".fc-agenda-days tbody").offset()
									var top = $(this).offset().top
									if (max && top<max.top){
										var difference = max.top-top
										$(pop).css("top",parseInt($(pop).css("top"))+difference)
									}else{
									
									}
									if($(pop).hasClass("top"))
										$(pop).find(".arrow").css("borderTopColor",color);
									if($(pop).hasClass("bottom"))
										$(pop).find(".arrow").css("borderBottomColor",color);
									if($(pop).hasClass("left"))
										$(pop).find(".arrow").css("borderLeftColor",color);
									if($(pop).hasClass("right"))
										$(pop).find(".arrow").css("borderRightColor",color);
								});
								
							}
							
						},
						// selection
						selectable : false,
						selectHelper : false,
						select : function(start, end, allDay) {
							//disabilitato
							return false
						},

						editable : true,

						droppable : true, // this allows things to be dropped onto the calendar !!!
						drop : function(date, allDay) { // this function is called when something is dropped
							ticket_id = $(this).data("cid")
							ticket = tickets.get({
								id : ticket_id
							})
							if (!(ticket)) return false;
							date_begin = format_date(date)
							date_end = moment(date).add('h', 2) // add 2 ore
							date_end = format_date(date_end)
							var form = new FormPlanView({
								'date_begin' : date_begin,
								'date_end' : date_end,
								'ticket' : ticket_id
							})
							jQuery(this).popover("hide")
							//jQuery(this).remove();
						},

						events : []
					});

	if(amode){
		$.contextMenu({
			selector : '.fc-event',
			callback : function(key, options) {
			},
			items : {
				"edit" : {
					name : gettext("Edit"),
					icon : "edit",
					callback : function(key, options) {
						var plan_id = $(options.$trigger).attr("plan_id")
						plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
						var plan = plans.get({
							id : plan_id
						})
						var form = new FormPlanView({
							model : plan
						})
					}
				},
				"cut" : {
					name : gettext("Delete"),
					icon : "cut",
					callback : function(key, options) {
						var plan_id = $(options.$trigger).attr("plan_id")
						plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
						var plan = plans.get({
							id : plan_id
						})
						plans.remove(plan)

					}
				},
				"mostra" : {
					name : gettext("Show all tickets of this project"),
					icon : "paste",
					callback : function(key, options) {
						var plan_id = $(options.$trigger).attr("plan_id")
						plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
						var plan = plans.get({
							id : plan_id
						})
						var ticket = plan.ticket()

						var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
						dialog = $("<div></div>").append(iframe).appendTo(
								"body").dialog({
							autoOpen : false,
							modal : true,
							resizable : true,
							width : "auto",
							height : "auto",
							close : function() {
								iframe.attr("src", "");
							},
							open: function(event, ui) {
								iframe.attr({
									width : '100%',
								});
								iframe.parents(".ui-dialog").css('width','1000px');
								$(".ui-dialog-titlebar-close").html("X")
						    }
						});

						var src = ticket.related_url()
						var title = gettext("Show all tickets of this project")
						var width = 1000
						var height = 400
						iframe.attr({
							width : +width,
							height : +height,
							src : src
						});
						dialog.dialog("option", "title", title).dialog(
								"open");

					}
				},
				"editicket" : {
					name : gettext("Edit Related Ticket"),
					icon : "edit",
					callback : function(key, options) {
						var plan_id = $(options.$trigger).attr("plan_id")
						plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
						var plan = plans.get({
							id : plan_id
						})
						var ticket = plan.ticket()
						var form = new FormTicketView({
							model : ticket
						})

					}
				}
			}
		});
	}else{
	$.contextMenu({
				selector : '.fc-event',
				callback : function(key, options) {
				},
				items : {
					"edit" : {
						name : gettext("Edit"),
						icon : "edit",
						callback : function(key, options) {
							var plan_id = $(options.$trigger).attr("plan_id")
							plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
							var plan = plans.get({
								id : plan_id
							})
							var form = new FormPlanView({
								model : plan
							})
						}
					},
					"cut" : {
						name : gettext("Delete"),
						icon : "cut",
						callback : function(key, options) {
							var plan_id = $(options.$trigger).attr("plan_id")
							plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
							var plan = plans.get({
								id : plan_id
							})
							plans.remove(plan)

						}
					},
					"mostra" : {
						name : gettext("Show all tickets of this project"),
						icon : "paste",
						callback : function(key, options) {
							var plan_id = $(options.$trigger).attr("plan_id")
							plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
							var plan = plans.get({
								id : plan_id
							})
							var ticket = plan.ticket()

							var iframe = $('<iframe frameborder="0" marginwidth="0" marginheight="0" allowfullscreen></iframe>');
							dialog = $("<div></div>").append(iframe).appendTo(
									"body").dialog({
								autoOpen : false,
								modal : true,
								resizable : true,
								width : "auto",
								height : "auto",
								close : function() {
									iframe.attr("src", "");
								},
								open: function(event, ui) {
									iframe.attr({
										width : '100%',
									});
									iframe.parents(".ui-dialog").css('width','1000px');
									$(".ui-dialog-titlebar-close").html("X")
							    }
							});

							var src = ticket.related_url()
							var title = gettext("Show all tickets of this project")
							var width = 1000
							var height = 400
							iframe.attr({
								width : +width,
								height : +height,
								src : src
							});
							dialog.dialog("option", "title", title).dialog(
									"open");

						}
					},
					"editicket" : {
						name : gettext("Edit Related Ticket"),
						icon : "edit",
						callback : function(key, options) {
							var plan_id = $(options.$trigger).attr("plan_id")
							plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
							var plan = plans.get({
								id : plan_id
							})
							var ticket = plan.ticket()
							var form = new FormTicketView({
								model : ticket
							})

						}
					},
					"nuovoassistenza" : {
						name : gettext("Add Assistance"),
						icon : "edit",
						callback : function(key, options) {
							var plan_id = $(options.$trigger).attr("plan_id")
							plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
							var plan = plans.get({
								id : plan_id
							})
							var form = new FormAssistenzaView({
								model : plan
							})

						}
					},
					"stampaplan" : {
						name : gettext("Print Plan"),
						icon : "copy",
						callback : function(key, options) {
							var plan_id = $(options.$trigger).attr("plan_id")
							plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
							var plan = plans.get({
								id : plan_id
							})
							if(plan){
								plan.load_pdf()
							
								return true
							}
							return false
						}
					},
					"planics" : {
						name : gettext("Send Invitation"),
						icon : "edit",
						callback : function(key, options) {
							var plan_id = $(options.$trigger).attr("plan_id")
							plan_id = (plan_id) ? plan_id: $(options.$trigger).attr("class").split("#")[1]
							var plan = plans.get({
								id : plan_id
							})
							if(plan){
								plan.send_invitation()
							
								return true
							}
							return false
						}
					}
				}
			});
	}
	$.contextMenu({
		selector : '.ticket',
		callback : function(key, options) {
		},
		items : {
			"edit" : {
				name : gettext("Edit"),
				icon : "edit",
				callback : function(key, options) {
					var ticket_id = $(options.$trigger).attr("cid")
					var ticket = tickets.get({
						id : ticket_id
					})
					var form = new FormTicketView({
						model : ticket
					})
				}
			},
			"editprj" : {
				name : gettext("Edit Project"),
				icon : "edit",
				callback : function(key, options) {
					var ticket_id = $(options.$trigger).attr("cid")
					var ticket = tickets.get({
						id : ticket_id
					})
					var form = new FormTicketProjectView({
						model : ticket
					})
				}
			},
			"close" : {
				name : gettext("Close"),
				icon : "delete",
				callback : function(key, options) {
					var ticket_id = $(options.$trigger).attr("cid")
					var ticket = tickets.get({
						id : ticket_id
					})
					ticket.chiudi()
				}
			},

		}
	});

	$(".modal").draggable({
		handle : ".modal-header"
	});

	$("#nuovoticket").click(function() {
		var form = new FormTicketView()
		return false;

	});

	$(document).on('click', ".fc-day-number", function(){
		datadate = $(this).parents("td").data("date")
		destination = new Date(datadate)
		$(calendar).fullCalendar('gotoDate', destination)
		$(calendar).fullCalendar( 'changeView', 'agendaDay' )
	})
		
	$(document).on('click', ".fc-week-number", function(){
		datadate = $(this).next().data("date")
		destination = new Date(datadate)
		$(calendar).fullCalendar('gotoDate', destination)
		$(calendar).fullCalendar( 'changeView', 'agendaWeek' )
	})
	
	$(document).on('click', ".fc-widget-header", function(){
		calendar_view = $(calendar).fullCalendar('getView')
		if (calendar_view.name !="agendaWeek") return false
		var index = $(this).index()-1
		var corrente = calendar_view = $(calendar).fullCalendar('getView').start
		var destination = new moment(corrente).add('d',index);
		$(calendar).fullCalendar('gotoDate', new Date(destination))
		$(calendar).fullCalendar( 'changeView', 'agendaDay' )
	})
	
	
	
		
	$(document).on('submit', ".sendform", function() {
		var data = $(this).serializeArray()
		var url= $(this).attr("action")
		$.ajax({
		  type: "POST",
		  url: url,
		  data: data
		});
		return false

	});
	/*
	 * pooling
	$.post('/admin/ticket/ticket/req/', {
	}, function(result) {
		console.log(result)
	})
	 */

};
//FUNZIONI PER PARSARE IL JSON
function plan_parse(data_json){
	delete data_json.fields.date_create
	delete data_json.fields.date_last_modify
	data_json.fields.date_begin = format_date(data_json.fields.date_begin)
	data_json.fields.date_end = format_date(data_json.fields.date_end)
	data_json.fields.start = data_json.fields.date_begin
	data_json.fields.end = data_json.fields.date_end
	data_json.fields.id = data_json.pk
	data_json.fields.title = data_json.extras.label
	data_json.fields.allDay = false
	return data_json.fields
}
function ticket_parse(data_json){
	data_json.fields.title = data_json.extras.label
	data_json.fields.id = data_json.pk
	data_json.fields.description = data_json.extras.label_description
	return data_json.fields
}

function iframe_message(msg){
	if( $("ul.messagelist").length==0){
		$(".breadcrumbs").after("<ul class='messagelist'></ul>")
	}
	$("ul.messagelist").html($("<li class='info'></li>").html(msg))
}
// funzione di comunicazione tra l iframe e il parent
// per la modifica\inserimento ticket
function iframe_callback(data_json) {
	dialog.dialog("close")
	
	//nel caso è una modifica di un progetto
	if(data_json.model=="ticket.ticketproject") return false;
	
	//nel caso è un plansend_u
	if(data_json.model=="ticket.plan"){
		data_json = plan_parse(data_json)
		//prende il plan se esiste
		var plan = plans.get({
			"id" : data_json.id
		})
		//se non esiste lo crea e lo aggiunge alla collezione
		if (plan == undefined) {
			plan = new Plan(data_json)
			plans.add(plan)
			if(plan.ticket()){
				plan.ticket().set("to_be_planned",false)
			}
		//altrimenti lo crea
		}else{
			plan.update(data_json)
			plan.render()
		}
		
		return true;
	}
	
	if(data_json.model=="ticket.ticket"){
		data_json = ticket_parse(data_json)
		//prende il ticket se esiste
		var ticket = tickets.get({
			"id" : data_json.id
		})
		//se non esiste lo crea e lo aggiunge alla collezione(ticketboard)
		if (ticket == undefined) {
			ticket = new Ticket(data_json)
			tickets.add(ticket)
		//altrimenti lo crea
		} else {
			ticket.update(data_json)
		}
		return true
	}
	
	if(data_json.model=="ticket.ticketassistance"){
		data_json = plan_parse(data_json)
		//prende il plan se esiste
		var plan = plans.get({
			"id" : data_json.id
		})
		//se non esiste lo crea e lo aggiunge alla collezione
		if (plan == undefined) {
			plan = new Plan(data_json)
			plans.add(plan)
			if(plan.ticket()){
				plan.ticket().set("to_be_planned",false)
			}
		//altrimenti lo crea
		}else{
			plan.update(data_json)
			plan.render()
		}
		
		return true;
	}
	
	
	
}
