# -*- coding: utf-8 -*-

from django.utils.translation import ugettext as _
from django.core.urlresolvers import reverse
from admin_tools.menu import items, Menu

from jmb.core.middleware.thread_local import get_current_user
from jmb.core.admin.menu import register_menu

ticket_menu_item = items.MenuItem(
    # GENERAL
    _('Ticket'), 
    reverse('admin:app_list', kwargs={'app_label': 'ticket'}),
    children=[
        items.MenuItem(_('Ticket'), '',
            children=[
                items.MenuItem(_('Calendar List'), reverse('admin:ticket_ticket_calendar_list',) + '?priority__lt=11'),
                items.MenuItem(_('Add Ticket'), reverse('admin:ticket_ticket_add',)),
                items.MenuItem(_('Ticket List'), reverse('admin:ticket_ticket_changelist',) ),
                items.MenuItem(_('Add Assistance'), reverse('admin:ticket_ticketassistance_add',)),
                items.MenuItem(_('Assistance List'), reverse('admin:ticket_ticketassistance_changelist',) ),
                # items.MenuItem(_('Add Project'), reverse('admin:ticket_ticketproject_add',)),
                # items.MenuItem(_('Project List'), reverse('admin:ticket_ticketproject_changelist',) ),
                items.MenuItem(_('Add Plan'), reverse('admin:ticket_plan_add',)),
                items.MenuItem(_('Plan List'), reverse('admin:ticket_plan_changelist',) ),
            ]
        ),
    ]
)

register_menu(ticket_menu_item, 'jmb.ticket')
