# -*- coding: utf-8 -*-

from django.core.urlresolvers import reverse
from django.utils.translation import ugettext_lazy as _
from admin_tools.dashboard import modules, Dashboard, AppIndexDashboard

#from jmb.product.dashboard import ProductDashboard
from jmb.core.admin import dashboard

class JumboDashboard(Dashboard):
#    class Media:
#        css = ('office_thunder/css/dashboard.css',)
#
    def __init__(self, **kwargs):
        Dashboard.__init__(self, **kwargs)
        self.columns = 3

    def init_with_context(self, context):
        request = context['request']

        # ADMINISTRATION dashboard
        self.children.append(modules.AppList(
            title=_('Administration'),
            models=('django.contrib.*',),
        ))

        # ACTION dashboard
        self.children.append(modules.RecentActions(_('Recent Actions'), 5))

        # CUSTOM dashboard

        for dash in dashboard.registry.values():
            self.children.append(dash(),)

