# coding: utf-8

from django.core.urlresolvers import reverse
from django.utils.translation import ugettext_lazy as _
from django.conf import settings

from admin_tools.menu import items, Menu
from jmb.core.admin import menu as jmb_menu

HIDDEN_APPS = (
    'jmb.organization',
    'jmb.office',
    'jmb.event',
    'jmb.project',
    'jmb.ticket',
    'jmb.bank',
    'jmb.vat',
    'jmb.currency',
    'jmb.carriage',
    'jmb.payment',
    'jmb.fax',

    )
# Let's register all applications
for app_name in settings.INSTALLED_APPS:
    if app_name.startswith('jmb') or app_name.startswith('cogema'):
        if app_name in HIDDEN_APPS:
            continue
        try:
            __import__('%s.jmenu' % app_name, {}, {} , ())
        except ImportError:
            pass
import web.admin.ticket_menu

class JumboMenu(Menu):
    def __init__(self, **kwargs):
        Menu.__init__(self, **kwargs)
        self.children += [
            items.MenuItem('Home', reverse('admin:index')),
            items.MenuItem('Docs', '/docs/index.html'),
        ]
        for menu in jmb_menu.registry.values():
            self.children.append(menu,)
