import os 

import autocomplete_light
import admin_tools.dashboard
from django.conf import urls, settings
from django.views.generic import RedirectView
from django.conf.urls.defaults import url, include, patterns
from django.contrib import admin
from django.conf import settings
from django.contrib.staticfiles.urls import staticfiles_urlpatterns

from dajaxice.core import dajaxice_autodiscover, dajaxice_config
from jmb.core import monkey
monkey.patch(exclude=['namespaces'])

autocomplete_light.autodiscover() 
admin.autodiscover()
admin_tools.dashboard.autodiscover()
dajaxice_autodiscover()

DOCS_DIR = os.path.join(os.path.dirname(settings.PROJECT_PATH), 'docs/_build/html')
js_catalog_info = {
                'domain': 'djangojs',
    'packages': ('web',),
}
urlpatterns = patterns('',
    url(r'^tinymce/', include('tinymce.urls')),
    url(r'^admin/', include(admin.site.urls)),
    url(r'^admin_tools/', include('admin_tools.urls')),
    url(r'autocomplete/', include('autocomplete_light.urls')),
    url(dajaxice_config.dajaxice_url, include('dajaxice.urls')),
    url(r'^docs/(?P<path>.*)$', 'django.views.static.serve',
        {'document_root': DOCS_DIR, 'show_indexes': True}
    ),
    (r'^comments/', include('django.contrib.comments.urls')),
    (r'^jsi18n/$',  include('jmb.i18n.urls')),
    url(r'ticket/', include('jmb.ticket.urls')),
)
# Default
if settings.CMS_ENABLED:
    urlpatterns += patterns('',
        url(r'^', include('cms.urls')),
    )
else:
    urlpatterns += patterns('django.views.generic.simple',
       ('^$', RedirectView.as_view(url='/admin/', permanent=True)), 
    )

urlpatterns += staticfiles_urlpatterns() # comment out when in production

if settings.DEBUG:
    urlpatterns = patterns('',
        url(r'^media/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}),
        url(r'', include('django.contrib.staticfiles.urls'),),
    ) + urlpatterns


